# Copy best models to local folder defined by the folders, the model names and the epoch number 
# This is an important preliminary step for inference time measurement.

import shutil
import os

model_path_root = '/net/travail/bformanek/checkpoints/'
local_root = '/net/cremi/bformanek/TRDP_II/local_models/'

model_folders = ['transfer_checkpoints_efficientnet_b0_adam_amp_criterion_balanced', 
                 'transfer_checkpoints_resnet50_adam_amp_criterion_balanced',
                 'transfer_checkpoints_resnet18_adam_amp_criterion_balanced',
                 'transfer_checkpoints_resnet18.a2_in1k',
                 'transfer_checkpoints_resnet18.fb_ssl_yfcc100m_ft_in1k',
                 'transfer_checkpoints_mobilenetv3_small_100.lamb_in1k',
                 'transfer_checkpoints_mobilenetv4_conv_large.e500_r256_in1k',
                 'transfer_checkpoints_mobilenetv4_hybrid_medium.e500_r224_in1k',
                 'transfer_checkpoints_resnet18_augmentation1',
                 'transfer_checkpoints_resnet18_augmentation2',
                 'transfer_checkpoints_resnet18_augmentation3',
                 'transfer_checkpoints_resnet18_augmentation4'
                 'transfer_checkpoints_resnet18_flips',
                 'transfer_checkpoints_resnet18_flips_90',
                 'transfer_checkpoints_resnet18_flips_180',
                 'transfer_checkpoints_resnet18_flips_360',
                 'transfer_checkpoints_resnet18_flips_90_resample']

best_epochs = [26, 18, 25, 12, 22, 28, 4, 7, 21, 19, 3, 24, 22, 13, 22, 22, 16]

for i in range(len(model_folders)):
    model_path = model_path_root + model_folders[i] + '/'
    epoch_number = best_epochs[i]
    model_name = f'avp_{epoch_number:03d}.pkl'
    model_path = model_path + model_name
    
    local_path = local_root + model_folders[i] + '_' + model_name
    
    if not os.path.isfile(local_path):
        print("Copy model " + model_path + " to " + local_path)
        shutil.copyfile(model_path, local_path)
        