import seaborn as sns

INDIVIDUALS = 1941
cmap = sns.color_palette("icefire", as_cmap=True)
spectral_colors = [cmap(i / 6) for i in range(7)]

# DATA SET
data_colors = {'N1': spectral_colors[0],'N2': spectral_colors[2],'N3': spectral_colors[4],'N3_c1': spectral_colors[5],'N3_c2': spectral_colors[6]}
data_shapes = {'N1': 'o', 'N2': 's', 'N3': '*', 'N3_c1': 'D', 'N3_c2': '^'}

# METHODS
methods_colors = {
    'SM-GI': spectral_colors[0],'SM-GI-Avg': spectral_colors[1],'SM-DP': spectral_colors[2],
    'Ens-GI': spectral_colors[3],'Ens-SP-O': spectral_colors[4],
    'SM-SP-O': spectral_colors[5],'SM-SP-O-Avg': spectral_colors[6]
}

methods_shapes = {'SM-GI': 'o', 'SM-GI-Avg': 's', 'SM-DP': '^', 
          'Ens-GI': 'X', 'Ens-SP-O': 'P',
          'SM-SP-O': 'D', 'SM-SP-O-Avg': 'H'}

# AUGMENTATION
augmentation_colors = {'-': spectral_colors[0], 'flip': spectral_colors[2], 'flip+rotation': spectral_colors[4], 'flip + rotation + scale': spectral_colors[6]}
augmentation_shapes = {'-': 'o', 'flip': 's', 'flip+rotation': '^', 'flip + rotation + scale': '*'}
augmentation_shapes_same = {'-': 'o', 'flip': 'o', 'flip+rotation': 'o', 'flip + rotation + scale': 'o'}

# MODELS
models_colors = {'resnet18': 'orange', 'resnet18.a2_in1k': 'blue'}
models_shapes = {'resnet18': 'o', 'resnet18.a2_in1k': 's'}